﻿using System.IO;
using Styx;
using Styx.Common;
using Styx.Helpers;

namespace HSV
{
    public class BurstKeySettings : Settings
    {
        public static readonly BurstKeySettings myPrefs = new BurstKeySettings();

        public BurstKeySettings()
            : base(
                Path.Combine(Utilities.AssemblyDirectory,
                    string.Format(@"Routines/HSV/Settings/{0}/BurstKeySettingsHSV-{1}.xml", StyxWoW.Me.RealmName, StyxWoW.Me.Name))
                )
        {
        }
        [Setting, DefaultValue(false)]
        public bool useBurstMode { get; set; }

        [Setting]
        [DefaultValue(false)]
        public bool useBurstCrows { get; set; }

        [Setting, DefaultValue(false)]
        public bool useBurstRapidFire { get; set; }

        [Setting, DefaultValue(false)]
        public bool useBurstStampede { get; set; }

        [Setting, DefaultValue(false)]
        public bool useBurstTrinket1 { get; set; }

        [Setting, DefaultValue(false)]
        public bool useBurstTrinket2 { get; set; }

        [Setting, DefaultValue(false)]
        public bool useBurstEngiGloves { get; set; }

        [Setting, DefaultValue(false)]
        public bool useBurstBerserking { get; set; }

        [Setting, DefaultValue(false)]
        public bool useBurstBloodFury { get; set; }


    }
}
