﻿using CommonBehaviors.Actions;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Media;
using Action = Styx.TreeSharp.Action;


namespace HSV
{
    public partial class Main : CombatRoutine
    {
        #region spells
        string ARCANE_SHOT = "Arcane Shot";
        string EXPLOSIVE_SHOT = "Explosive Shot";
        int EXPLOSIVE_SHOT_INT = 53301;
        string BLACK_ARROW = "Black Arrow";
        string SERPENT_STING = "Serpent Sting";
        string CONCUSSIVE_SHOT = "Concussive Shot";
        string STEADY_SHOT = "Steady Shot";
        string GLAIVE_TOSS = "Glaive Toss";
        string COBRA_SHOT = "Cobra Shot";
        string KILL_SHOT = "Kill Shot";
        string MULTI_SHOT = "Multi-Shot";
        string ICE_TRAP = "Ice Trap";
        string SNAKE_TRAP = "Snake Trap";
        string EXPLOSIVE_TRAP = "Explosive Trap";
        string FROST_TRAP = "Frost Trap";
        string MURDER_OF_CROWS = "A Murder of Crows";
        string STAMPEDE = "Stampede";
        string DIRE_BEAST = "Dire Beast";
        string RAPID_FIRE = "Rapid Fire";
        string MISIRECTION = "Misdirection";
        string TRAP_LAUNCHER = "Trap Launcher";
        string ASPECT_OF_THE_HAWK = "Aspect of the Hawk";
        string ASPECT_OF_THE_IRON_HAWK = "Aspect of the Iron Hawk";
        string MEND_PET = "Mend Pet";
        string BLOOD_FURY = "Blood Fury";
        string COUNTER_SHOT = "Counter Shot";
        string DISENGAGE = "Disengage";
        #endregion

        
        #region Call Pet
        string LastPetCall = string.Empty;
        private DateTime nextPetCallCheckAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 3000);

        private DateTime nextPetCheckAllowed;
        public void SetNextPetCheckAllowed()
        {
            nextPetCheckAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 3000);
        }
        Composite CallPet()
        {
            return (
                new Sequence(
                    new WaitContinue(3, ret => false, new ActionAlwaysSucceed()),
                    CreateCallPetBehavior()
                    ));
        }
        Composite CreateCallPetBehavior()
        {
            return new Action(ret =>
            {
                if (Me.Pet == null && !Me.GroupInfo.IsInRaid && !Me.IsInInstance)
                {
                    if (Me.Specialization == WoWSpec.None)
                    {
                        SpellManager.Cast("Call Pet 1");
                        Logging.Write("Call Pet 1");
                        SetNextPetCheckAllowed();
                        return RunStatus.Success;
                    }
                    
                    if (Me.Specialization == WoWSpec.HunterSurvival && MeIsSolo)
                    {
                        SpellManager.Cast("Call Pet " + SettingsCommon.myPrefs.CallSoloPet);
                        Logging.Write("Call Pet " + SettingsCommon.myPrefs.CallSoloPet);
                        SetNextPetCheckAllowed();
                        return RunStatus.Success;
                    }

                    LastPetCall = "Call Pet";
                }
                if (Me.Pet == null && (Me.GroupInfo.IsInRaid || Me.IsInInstance))
                {
                    SpellManager.Cast("Call Pet " + SettingsCommon.myPrefs.CallRaidPet);
                    Logging.Write("Call Pet " + SettingsCommon.myPrefs.CallRaidPet);
                    SetNextPetCheckAllowed();
                    LastPetCall = "Call Pet";
                    return RunStatus.Success;
                }
                if (Me.Pet == null && (Me.CurrentMap.IsBattleground || Me.CurrentMap.IsArena))
                {
                    SpellManager.Cast("Call Pet " + SettingsCommon.myPrefs.CallBgPet);
                    Logging.Write("Call Pet " + SettingsCommon.myPrefs.CallBgPet);
                    LastPetCall = "Call Pet";
                    SetNextPetCheckAllowed();
                    return RunStatus.Success;
                }
                if (Me.Pet == null && LastPetCall != string.Empty)
                {
                    SpellManager.Cast("Revive Pet");
                    Logging.Write("Revive Pet");
                    SetNextPetCheckAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        Composite ReviveMyPet()
        {
            return new Action(ret =>
            {
                SpellManager.Cast("Revive Pet");
                Logging.Write("Revive Pet");
                SetNextPetCheckAllowed();
                return RunStatus.Success;
            });
        }
        #endregion

        #region take pets target
        Composite TakePetsTarget()
        {
            return new Action(ret =>
            {

                if (Me.Pet.CurrentTarget != null)
                {
                    Me.ClearTarget();
                    Logging.Write(Colors.PaleGreen, "Taking my Pet's Target");
                    Me.Pet.CurrentTarget.Target();
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region berserking
        private DateTime nextBerserkingAllowed;
        public void SetNextBerserkingAllowed()
        {
            nextBerserkingAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 2500);
        }
        Composite CastBerserking()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(BERSERKING))
                {
                    SpellManager.Cast(BERSERKING);
                    Logging.Write(Colors.Orange, BERSERKING);
                    SetNextBerserkingAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region blood fury
        private DateTime nextBloodFuryAllowed;
        public void SetNextBloodFuryAllowed()
        {
            nextBloodFuryAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 2500);
        }
        Composite CastBloodFury()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(BLOOD_FURY))
                {
                    SpellManager.Cast(BLOOD_FURY);
                    Logging.Write(Colors.Orange, BLOOD_FURY);
                    SetNextBloodFuryAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region MendPet
        private DateTime nextMendPetAllowed;
        public void SetNextMendPetAllowed()
        {
            nextMendPetAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 2500);
        }
        Composite CastMendPet()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(MEND_PET))
                {
                    SpellManager.Cast(MEND_PET);
                    Logging.Write(Colors.SeaGreen, MEND_PET);

                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region aspect
        Composite BuffAspect()
        {
            return new Action(ret =>
            {
                if(SpellManager.HasSpell(ASPECT_OF_THE_HAWK) 
                    && !SpellManager.HasSpell(ASPECT_OF_THE_IRON_HAWK)
                    && !buffExists(ASPECT_OF_THE_HAWK, Me)
                    && SpellManager.CanCast(ASPECT_OF_THE_HAWK)) 
                {
                    SpellManager.Cast(ASPECT_OF_THE_HAWK, Me);
                    Logging.Write(Colors.Orange, ASPECT_OF_THE_HAWK);
                    SetNextBuffAllowed();
                    return RunStatus.Success;
                }
                if (SpellManager.HasSpell(ASPECT_OF_THE_IRON_HAWK) 
                    && SpellManager.CanCast(ASPECT_OF_THE_IRON_HAWK)
                    && !buffExists(ASPECT_OF_THE_IRON_HAWK, Me))
                {
                    SpellManager.Cast(ASPECT_OF_THE_IRON_HAWK, Me);
                    Logging.Write(Colors.Orange, ASPECT_OF_THE_IRON_HAWK);
                    SetNextBuffAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region trap launcher
        Composite BuffTrapLauncher()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(TRAP_LAUNCHER))
                {
                    SpellManager.Cast(TRAP_LAUNCHER, Me);
                    Logging.Write(Colors.Orange, TRAP_LAUNCHER);
                    SetNextBuffAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region Explosive Shot Proc
        Composite CastExplosiveShotproc()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(EXPLOSIVE_SHOT))
                {
                    SpellManager.Cast(EXPLOSIVE_SHOT);
                    Logging.Write(Colors.Yellow, EXPLOSIVE_SHOT + " Proc");
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region explosive shot
        private DateTime nextExplosiveShotAllowed;
        public void SetNextExplosiveShotAllowed()
        {
            nextExplosiveShotAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 2500);
        }
        Composite CastExplosiveShot()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(EXPLOSIVE_SHOT))
                {
                    SpellManager.Cast(EXPLOSIVE_SHOT);
                    Logging.Write(Colors.Yellow, EXPLOSIVE_SHOT);
                    SetNextExplosiveShotAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region Black Arrow
        private DateTime nextBlackArrowAllowed;
        public void SetNextBlackArrowAllowed()
        {
            nextBlackArrowAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 5000);
        }
        Composite CastBlackArrow()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(BLACK_ARROW))
                {
                    SpellManager.Cast(BLACK_ARROW);
                    Logging.Write(Colors.Yellow, BLACK_ARROW);
                    SetNextBlackArrowAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region Serpent Sting
        private DateTime nextSerpentStingAllowed;
        public void SetNextSerpentStingAllowed()
        {
            nextSerpentStingAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 2500);
        }
        Composite CastSerpentSting()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(SERPENT_STING))
                {
                    SpellManager.Cast(SERPENT_STING);
                    Logging.Write(Colors.Yellow, SERPENT_STING);
                    SetNextSerpentStingAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region Arcane Shot
        private DateTime nextArcaneShotAllowed;
        public void SetNextArcaneShotAllowed()
        {
            nextArcaneShotAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 1000);
        }
        Composite CastArcaneShot()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(ARCANE_SHOT))
                {
                    SpellManager.Cast(ARCANE_SHOT);
                    Logging.Write(Colors.Yellow, ARCANE_SHOT);
                    SetNextArcaneShotAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region cobra shot
        private DateTime nextFocusShotAllowed;
        public void SetNextFocusShotAllowed()
        {
            nextFocusShotAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 2000);
        }
        Composite CastCobraShot()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(COBRA_SHOT))
                {
                    SpellManager.Cast(COBRA_SHOT);
                    Logging.Write(Colors.Yellow, COBRA_SHOT);
                    SetNextFocusShotAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region steady shot
        Composite CastSteadyShot()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(STEADY_SHOT))
                {
                    SpellManager.Cast(STEADY_SHOT);
                    Logging.Write(Colors.Yellow, STEADY_SHOT);
                    SetNextFocusShotAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region Stampede
        private DateTime nextStampedeAllowed;
        public void SetNextStampedeAllowed()
        {
            nextStampedeAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 5000);
        }
        Composite CastStampede()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(STAMPEDE))
                {
                    SpellManager.Cast(STAMPEDE);
                    Logging.Write(Colors.Yellow, STAMPEDE);
                    SetNextStampedeAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region Murder of Crows
        private DateTime nextMurderOfCrowsAllowed;
        public void SetNextMurderOfCrowsAllowed()
        {
            nextMurderOfCrowsAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 5000);
        }
        Composite CastMurderOfCrows()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(MURDER_OF_CROWS))
                {
                    SpellManager.Cast(MURDER_OF_CROWS);
                    Logging.Write(Colors.Yellow, MURDER_OF_CROWS);
                    SetNextMurderOfCrowsAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region DireBeast
        private DateTime nextDireBeastAllowed;
        public void SetNextDireBeastAllowed()
        {
            nextDireBeastAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 5000);
        }
        Composite CastDireBeast()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(DIRE_BEAST))
                {
                    SpellManager.Cast(DIRE_BEAST);
                    Logging.Write(Colors.Yellow, DIRE_BEAST);
                    SetNextDireBeastAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region Glaive Toss
        private DateTime nextGlaiveTossAllowed;
        public void SetNextGlaiveTossAllowed()
        {
            nextGlaiveTossAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 2500);
        }
        Composite CastGlaiveToss()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(GLAIVE_TOSS))
                {
                    if (SettingsCommon.myPrefs.MisdirectionUse == SettingsCommon.useMisdirect.Auto
                        && MeIsSolo
                        && !buffExists(MISIRECTION, Me)
                        && SpellManager.HasSpell(MISIRECTION)
                        && !spellOnCooldown(MISIRECTION)
                        && nextMisShotAllowed <= DateTime.Now
                        && SpellManager.CanCast(MISIRECTION))
                    {
                        Lua.DoString("RunMacroText('/cast [@focus,help][help][@pet,exists] Misdirection');");
                        SetNextMisShotAllowed();
                    }
                    SpellManager.Cast(GLAIVE_TOSS);
                    Logging.Write(Colors.Yellow, GLAIVE_TOSS);
                    SetNextGlaiveTossAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region Rapid Fire
        private DateTime nextRapidFireAllowed;
        public void SetNextRapidFireAllowed()
        {
            nextRapidFireAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 2500);
        }
        Composite CastRapidFire()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(RAPID_FIRE))
                {
                    SpellManager.Cast(RAPID_FIRE);
                    Logging.Write(Colors.Yellow, RAPID_FIRE);
                    SetNextRapidFireAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region Kill Shot
        private DateTime nextKillShotAllowed;
        public void SetNextKillShotAllowed()
        {
            nextKillShotAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 2500);
        }
        Composite CastKillShot()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(KILL_SHOT))
                {
                    SpellManager.Cast(KILL_SHOT);
                    Logging.Write(Colors.Yellow, KILL_SHOT);
                    SetNextKillShotAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region Concussive shot
        private DateTime nextConShotAllowed;
        public void SetNextConShotAllowed()
        {
            nextConShotAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 1000);
        }
        Composite CastConcussiveShot()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(CONCUSSIVE_SHOT))
                {
                    SpellManager.Cast(CONCUSSIVE_SHOT);
                    Logging.Write(Colors.Yellow, CONCUSSIVE_SHOT);
                    SetNextConShotAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region MultiShot
        Composite CastMultiShot()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(MULTI_SHOT))
                {
                    if (SettingsCommon.myPrefs.MisdirectionUse == SettingsCommon.useMisdirect.Auto
                        && MeIsSolo
                        && !buffExists(MISIRECTION, Me)
                        && SpellManager.HasSpell(MISIRECTION)
                        && !spellOnCooldown(MISIRECTION)
                        && nextMisShotAllowed <= DateTime.Now
                        && SpellManager.CanCast(MISIRECTION))
                    {
                        Lua.DoString("RunMacroText('/cast [@focus,help][help][@pet,exists] Misdirection');");
                        SetNextMisShotAllowed();
                    }
                    SpellManager.Cast(MULTI_SHOT);
                    Logging.Write(Colors.Yellow, MULTI_SHOT);
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region countershot
        private DateTime nextCounterShotAllowed;
        public void SetNextCounterShotAllowed()
        {
            nextCounterShotAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 2500);
        }
        Composite CastCounterShot()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(COUNTER_SHOT))
                {
                    SpellManager.Cast(COUNTER_SHOT);
                    Logging.Write(Colors.Yellow, COUNTER_SHOT);
                    SetNextCounterShotAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion
        
        #region disengage
        private DateTime nextDisengageAllowed;
        public void SetNextDisengageAllowed()
        {
            nextDisengageAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 2500);
        }
        Composite CastDisengage()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(DISENGAGE))
                {
                    SpellManager.Cast(DISENGAGE);
                    Logging.Write(Colors.Yellow, DISENGAGE);
                    SetNextDisengageAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region traps
        private DateTime nextTrapAllowed;
        public void SetNextTrapAllowed()
        {
            nextTrapAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 5000);
        }
        Composite CastExplosiveTrap()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(EXPLOSIVE_TRAP))
                {
                    SpellManager.Cast(EXPLOSIVE_TRAP);
                    SpellManager.ClickRemoteLocation(Me.CurrentTarget.Location);
                    Logging.Write(Colors.LightBlue, EXPLOSIVE_TRAP);
                    SetNextTrapAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        Composite CastSnakeTrap()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(SNAKE_TRAP))
                {
                    SpellManager.Cast(SNAKE_TRAP);
                    SpellManager.ClickRemoteLocation(Me.CurrentTarget.Location);
                    Logging.Write(Colors.LightBlue, SNAKE_TRAP);
                    SetNextTrapAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        Composite CastIceTrap()
        {
            return new Action(ret =>
            {
                if (SpellManager.CanCast(ICE_TRAP))
                {
                    SpellManager.Cast(ICE_TRAP);
                    SpellManager.ClickRemoteLocation(Me.CurrentTarget.Location);
                    Logging.Write(Colors.LightBlue, ICE_TRAP);
                    SetNextTrapAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion traps

        #region misdirection use
        private DateTime nextMisShotAllowed;
        public void SetNextMisShotAllowed()
        {
            nextMisShotAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 5000);
        }
        Composite CastMisdirection()
        {
            return new Action(ret =>
            {
                if (SettingsCommon.myPrefs.MisdirectionUse == SettingsCommon.useMisdirect.Auto && SpellManager.CanCast(MISIRECTION))
                {
                    Lua.DoString("RunMacroText('/cast [@focus,help][help][@pet,exists] Misdirection');");
                    SetNextMisShotAllowed();
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region IsInRange
        public bool IsInRange(float range, WoWUnit target)
        {
            return target.Location.Distance(Me.Location) <= range;
        }
        #endregion

        #region pause check
        Composite isCRPaused()
        {
            return new Action(ret =>
            {
                return;
            });
        }
        #endregion

        #region AutoBot
        bool AutoBot
        {
            get
            {
                return usedBot.Contains("QUEST") || usedBot.Contains("GRIND") || usedBot.Contains("GATHER") || usedBot.Contains("ANGLER");

            }
        }
        #endregion

        #region logs
        public void LogMsg(string msg)
        {
            Logging.Write(msg);
        }
        #endregion logs

        #region can buff
        private DateTime nextBuffAllowed;
        public void SetNextBuffAllowed()
        {
            nextBuffAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 1000);
        }
        public bool CanBuff
        {
            get
            {
                return !Me.Mounted && !Me.IsFlying && !Me.OnTaxi && !Me.IsDead && !Me.IsGhost;
            }
        }
        #endregion

        #region can eat
        public bool CanEat
        {
            get
            {
                return !Me.Mounted && !Me.IsFlying && !Me.OnTaxi && !Me.IsDead && !Me.IsGhost && !Me.IsSwimming;
            }
        }
        Composite EatFood()
        {
            return new Action(ret =>
            {
                Styx.CommonBot.Rest.Feed();
                return RunStatus.Failure;
            });
        }
        #endregion

        #region gotTarget
        public bool gotTarget
        {
            get
            {
                return Me.CurrentTarget != null && !Me.CurrentTarget.IsDead && !Me.CurrentTarget.IsFriendly && Me.CurrentTarget.Attackable && Me.CurrentTarget.CanSelect;
            }
        }
        #endregion

        #region hastebuffs
        string TIME_WARP = "Time Warp";
        string HEROISM = "Heroism";
        string BLOODLUST = "Bloodlust";
        string DRUMS_OF_RAGE = "Drums of Rage";
        string BERSERKING = "Berserking";
        string ANCIENT_HYSTERIA = "Ancient Hysteria";
        public bool NotHaveHasteBuffs
        {
            get
            {
                return !buffExists(HEROISM, Me)
                    && !buffExists(TIME_WARP, Me)
                    && !buffExists(BLOODLUST, Me)
                    && !buffExists(DRUMS_OF_RAGE, Me)
                    && !buffExists(ANCIENT_HYSTERIA, Me);
            }
        }
        #endregion

        #region overlayed
        public bool IsOverlayed(int spellID)
        {
            return Lua.GetReturnVal<bool>("return IsSpellOverlayed(" + spellID + ")", 0);
        }
        #endregion overlayed

        #region addcount
        IEnumerable<WoWUnit> UnfriendlyRangedUnits
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>(true, false).Where(u => u != null
                    && !u.IsDead
                    && u.CanSelect
                    && u.Attackable
                    && !u.IsFriendly
                    && u.Location.Distance(Me.CurrentTarget.Location) <= 10);
            }
        }
        IEnumerable<WoWUnit> UnfriendlyMeleeUnits
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>(true, false).Where(u => u != null
                    && !u.IsDead
                    && u.CanSelect
                    && u.Attackable
                    && !u.IsFriendly
                    && u.IsWithinMeleeRange);
            }
        }
        #endregion

        #region movement targeting facing
        [DllImport("user32.dll")]
        private static extern short GetAsyncKeyState(Keys vKey);

        public bool AllowFacing
        {
            get
            {
                if (SettingsCommon.myPrefs.AutoFacingRaid
                    && (Me.GroupInfo.IsInRaid || Me.IsInInstance || Me.GroupInfo.IsInParty))
                {
                    return false;
                }
                if ((GetAsyncKeyState(Keys.LButton) != 0
                    && GetAsyncKeyState(Keys.RButton) != 0) ||
                    GetAsyncKeyState(Keys.W) != 0 ||
                    GetAsyncKeyState(Keys.S) != 0 ||
                    GetAsyncKeyState(Keys.D) != 0 ||
                    GetAsyncKeyState(Keys.A) != 0)
                {
                    return false;
                }
                return SettingsCommon.myPrefs.AutoFacing;

            }
        }
        public bool AllowTargeting
        {
            get
            {
                if (SettingsCommon.myPrefs.AutoTargetingRaid
                    && (Me.GroupInfo.IsInRaid || Me.IsInInstance || Me.GroupInfo.IsInParty))
                {
                    return false;
                }
                if ((GetAsyncKeyState(Keys.LButton) != 0
                    && GetAsyncKeyState(Keys.RButton) != 0) ||
                    GetAsyncKeyState(Keys.W) != 0 ||
                    GetAsyncKeyState(Keys.S) != 0 ||
                    GetAsyncKeyState(Keys.D) != 0 ||
                    GetAsyncKeyState(Keys.A) != 0)
                {
                    return false;
                }
                return SettingsCommon.myPrefs.AutoTargeting;
            }
        }
        public bool AllowMovement
        {
            get
            {
                if (SettingsCommon.myPrefs.AutoMovementRaid
                    && (Me.GroupInfo.IsInRaid || Me.IsInInstance || Me.GroupInfo.IsInParty))
                {
                    return false;
                }
                if ((GetAsyncKeyState(Keys.LButton) != 0
                    && GetAsyncKeyState(Keys.RButton) != 0) ||
                    GetAsyncKeyState(Keys.W) != 0 ||
                    GetAsyncKeyState(Keys.S) != 0 ||
                    GetAsyncKeyState(Keys.D) != 0 ||
                    GetAsyncKeyState(Keys.A) != 0)
                {
                    return false;
                }


                return SettingsCommon.myPrefs.AutoMovement;
            }
        }

        Composite CreateMovementBehavior()
        {
            return
                    new Action(ret =>
                    {
                        Navigator.MoveTo(StyxWoW.Me.CurrentTarget.Location);
                        return RunStatus.Failure;
                    }
                );
        }
        Composite CreateStopMovement()
        {
            return new Action(ret =>
            {
                Navigator.PlayerMover.MoveStop();
                return RunStatus.Failure;
            });
        }
        Composite CreateMoveBackBehavior()
        {
            return new Action(ret =>
            {
                WoWMovement.Move(WoWMovement.MovementDirection.Backwards);
                while (gotTarget && Me.CurrentTarget.IsAlive && Me.CurrentTarget.Distance < 10)
                {
                    break;
                }
                Navigator.PlayerMover.MoveStop();
                return RunStatus.Failure;
            });
        }
        #endregion

        #region facing
        Composite FaceMyTarget()
        {
            return
                new Action(ret =>
                {
                    Me.CurrentTarget.Face();
                    return RunStatus.Failure;
                });
        }
        #endregion

        #region solo

        public bool MeIsSolo
        {
            get
            {
                return !Me.CurrentMap.IsRaid
                    && !Me.CurrentMap.IsDungeon
                    && !Me.CurrentMap.IsScenario
                    && !Me.CurrentMap.IsInstance
                    && !Me.GroupInfo.IsInRaid
                    && !Me.GroupInfo.IsInParty
                    && !Me.CurrentMap.IsArena
                    && !Me.CurrentMap.IsBattleground;
            }
        }
        #endregion

        #region crowdcontrol

        public bool IsCrowdControlledTarget(WoWUnit unit)
        {
            Dictionary<string, WoWAura>.ValueCollection auras = unit.Auras.Values;

            return unit.Fleeing
                || HasAuraWithEffect(unit,
                        WoWApplyAuraType.ModConfuse,
                        WoWApplyAuraType.ModCharm,
                        WoWApplyAuraType.ModFear,
                        WoWApplyAuraType.ModPossess);
        }

        public bool IsCrowdControlledPlayer(WoWUnit unit)
        {
            Dictionary<string, WoWAura>.ValueCollection auras = unit.Auras.Values;

            return unit.Rooted
                || unit.Fleeing
                || HasAuraWithEffect(unit,
                        WoWApplyAuraType.ModConfuse,
                        WoWApplyAuraType.ModCharm,
                        WoWApplyAuraType.ModFear,
                        WoWApplyAuraType.ModDecreaseSpeed,
                        WoWApplyAuraType.ModPacify,
                        WoWApplyAuraType.ModPacifySilence,
                        WoWApplyAuraType.ModPossess,
                        WoWApplyAuraType.ModRoot);
        }
        public bool IsRooted(WoWUnit unit)
        {
            Dictionary<string, WoWAura>.ValueCollection auras = unit.Auras.Values;

            return unit.Rooted;
        }
        public bool HasAuraWithEffect(WoWUnit unit, WoWApplyAuraType applyType)
        {
            return unit.Auras.Values.Any(a => a.Spell != null && a.Spell.SpellEffects.Any(se => applyType == se.AuraType));
        }

        public static bool HasAuraWithEffect(WoWUnit unit, params WoWApplyAuraType[] applyType)
        {
            var hashes = new HashSet<WoWApplyAuraType>(applyType);
            return unit.Auras.Values.Any(a => a.Spell != null && a.Spell.SpellEffects.Any(se => hashes.Contains(se.AuraType)));
        }
        #endregion

        #region autoattack
        Composite AutoAttack()
        {
            return new Action(ret =>
            {
                Lua.DoString("StartAttack()");
                return RunStatus.Failure;
            });
        }
        #endregion

        #region FindTarget
        WoWUnit FindTarget()
        {
            WoWUnit myTarget = ObjectManager.GetObjectsOfType<WoWUnit>(true, false).Where(u => ValidUnit(u)
                && u.DistanceSqr <= 40 * 40
                && !Blacklist.Contains(u, BlacklistFlags.All))
                .OrderBy(u => u.IsPlayer)
                .ThenBy(u => u.Distance)
                .FirstOrDefault();
            if (myTarget != null)
            {
                Logging.Write(Colors.PaleGreen, "Found new Target " + myTarget.Name);
                myTarget.Target();
                return myTarget;
            }
            return null;
        }
        #endregion

        #region Kind of target
        public bool IsWoWBoss(WoWUnit mytarget)
        {
            if (StyxWoW.Me.CurrentTarget != null)
            {
                if (StyxWoW.Me.CurrentTarget.CreatureRank == WoWUnitClassificationType.WorldBoss)
                {
                    return true;
                }
                else if (target.IsBoss(mytarget))
                {
                    return true;
                }
                else if (Me.CurrentTarget.MaxHealth >= (100 * 1000000)) { return true; }
                else if (StyxWoW.Me.CurrentTarget.CreatureRank == WoWUnitClassificationType.RareElite
                    && StyxWoW.Me.CurrentTarget.MaxHealth >= (StyxWoW.Me.MaxHealth * 3)
                    && (!StyxWoW.Me.GroupInfo.IsInParty
                    || StyxWoW.Me.GroupInfo.NumPartyMembers <= 3)
                    && !StyxWoW.Me.GroupInfo.IsInRaid
                    && !StyxWoW.Me.IsInInstance)
                {
                    return true;
                }
                else if (StyxWoW.Me.CurrentTarget.CreatureRank == WoWUnitClassificationType.Rare
                    && StyxWoW.Me.CurrentTarget.MaxHealth >= (StyxWoW.Me.MaxHealth * 3)
                    && (!StyxWoW.Me.GroupInfo.IsInParty
                    || StyxWoW.Me.GroupInfo.NumPartyMembers <= 3)
                    && !StyxWoW.Me.GroupInfo.IsInRaid
                    && !StyxWoW.Me.IsInInstance)
                {
                    return true;
                }
                else if (StyxWoW.Me.CurrentTarget.CreatureRank == WoWUnitClassificationType.Elite
                    && StyxWoW.Me.CurrentTarget.MaxHealth >= (StyxWoW.Me.MaxHealth * 3)
                    && (!StyxWoW.Me.GroupInfo.IsInParty
                    || StyxWoW.Me.GroupInfo.NumPartyMembers <= 3)
                    && !StyxWoW.Me.GroupInfo.IsInRaid
                    && !StyxWoW.Me.IsInInstance)
                {
                    return true;
                }
                else if (StyxWoW.Me.CurrentTarget.Name.Contains("Dummy")
                    && !StyxWoW.Me.IsInInstance)
                {
                    return true;
                }
                else if (StyxWoW.Me.CurrentTarget.IsPlayer
                    && !StyxWoW.Me.CurrentTarget.IsFriendly)
                {
                    return true;
                }
            }
            return false;
        }
        #endregion Kind of Target

        #region valid units
        public bool ValidUnit(WoWUnit p)
        {
            if (p == null || !p.IsValid)
                return false;

            // Ignore shit we can't select
            if (!p.CanSelect)
            {
                return false;
            }

            // Ignore shit we can't attack
            if (!p.Attackable)
            {
                return false;
            }

            // Duh
            if (p.IsDead)
            {
                return false;
            }

            // check for enemy players here as friendly only seems to work on npc's
            if (p.IsPlayer)
            {
                WoWPlayer pp = p.ToPlayer();
                if (pp.IsHorde == StyxWoW.Me.IsHorde)
                {
                    return false;
                }

                if (pp.Guid == StyxWoW.Me.CurrentTargetGuid && CanAttackCurrentTarget)
                {
                    return false;
                }

                return true;
            }

            // Ignore friendlies!
            if (p.IsFriendly)
            {
                return false;
            }
            // If it is a pet/minion/totem, lets find the root of ownership chain
            WoWPlayer pOwner = GetPlayerParent(p);

            // ignore if owner is player, alive, and not blacklisted then ignore (since killing owner kills it)
            // .. following .IsMe check to prevent treating quest mob summoned by us that we need to kill as invalid 
            if (pOwner != null && pOwner.IsAlive && !pOwner.IsMe)
            {
                if (!ValidUnit(pOwner))
                {
                    return false;
                }
                if (!Blacklist.Contains(pOwner, BlacklistFlags.Combat))
                {
                    return false;
                }
                if (!StyxWoW.Me.IsPvPFlagged)
                {
                    return false;
                }
            }

            // And ignore critters (except for those ferocious ones) /non-combat pets
            if (p.IsNonCombatPet)
            {
                return false;
            }

            // And ignore critters (except for those ferocious ones) /non-combat pets
            if (p.IsCritter && p.ThreatInfo.ThreatValue == 0 && !p.IsTargetingMyRaidMember)
            {
                return false;
            }
            /*
                        if (p.CreatedByUnitGuid != 0 || p.SummonedByUnitGuid != 0)
                            return false;
            */
            return true;
        }

        public WoWPlayer GetPlayerParent(WoWUnit unit)
        {
            // If it is a pet/minion/totem, lets find the root of ownership chain
            WoWUnit pOwner = unit;
            while (true)
            {
                if (pOwner.OwnedByUnit != null)
                    pOwner = pOwner.OwnedByRoot;
                else if (pOwner.CreatedByUnit != null)
                    pOwner = pOwner.CreatedByUnit;
                else if (pOwner.SummonedByUnit != null)
                    pOwner = pOwner.SummonedByUnit;
                else
                    break;
            }

            if (unit != pOwner && pOwner.IsPlayer)
                return pOwner as WoWPlayer;

            return null;
        }
        public bool CanAttackCurrentTarget
        {
            get
            {
                if (StyxWoW.Me.CurrentTarget == null)
                    return false;

                return Lua.GetReturnVal<bool>("return UnitCanAttack(\"player\",\"target\")", 0);
            }
        }
        #endregion

        #region Buff Checks

        public bool buffExists(int Buff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                var Results = onTarget.GetAuraById(Buff);
                if (Results != null)
                    return true;
            }
            return false;
        }

        public double buffTimeLeft(int Buff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                var Results = onTarget.GetAuraById(Buff);
                if (Results != null)
                {
                    if (Results.TimeLeft.TotalMilliseconds > 0)
                        return Results.TimeLeft.TotalMilliseconds;
                }
            }
            return 0;
        }

        public bool buffExists(string Buff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                var Results = onTarget.GetAuraByName(Buff);
                if (Results != null)
                    return true;
            }
            return false;
        }

        public double buffTimeLeft(string Buff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                var Results = onTarget.GetAuraByName(Buff);
                if (Results != null)
                {
                    if (Results.TimeLeft.TotalMilliseconds > 0)
                        return Results.TimeLeft.TotalMilliseconds;
                }
            }
            return 0;
        }



        public uint buffStackCount(int Buff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                var Results = onTarget.GetAuraById(Buff);
                if (Results != null)
                    return Results.StackCount;
            }
            return 0;
        }
        public uint buffStackCount(string Buff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                var Results = onTarget.GetAuraByName(Buff);
                if (Results != null)
                    return Results.StackCount;
            }
            return 0;
        }
        #endregion

        #region Cache Checks
        public IEnumerable<WoWAura> cachedAuras = new List<WoWAura>();
        public IEnumerable<WoWAura> cachedTargetAuras = new List<WoWAura>();
        public void getCachedAuras()
        {
            if (Me.CurrentTarget != null)
                cachedTargetAuras = Me.CurrentTarget.GetAllAuras();
            cachedAuras = Me.GetAllAuras();
        }
        #endregion

        #region Cooldown Checks
        private Dictionary<WoWSpell, long> Cooldowns = new Dictionary<WoWSpell, long>();
        public TimeSpan cooldownLeft(int Spell)
        {
            SpellFindResults Results;
            if (SpellManager.FindSpell(Spell, out Results))
            {
                WoWSpell Result = Results.Override ?? Results.Original;
                if (Cooldowns.TryGetValue(Result, out lastUsed))
                {
                    if (DateTime.Now.Ticks < lastUsed)
                        return Result.CooldownTimeLeft;
                    return TimeSpan.MaxValue;
                }
            }
            return TimeSpan.MaxValue;
        }
        public TimeSpan cooldownLeft(string Spell)
        {
            SpellFindResults Results;
            if (SpellManager.FindSpell(Spell, out Results))
            {
                WoWSpell Result = Results.Override ?? Results.Original;
                if (Cooldowns.TryGetValue(Result, out lastUsed))
                {
                    if (DateTime.Now.Ticks < lastUsed)
                        return Result.CooldownTimeLeft;
                    return TimeSpan.MaxValue;
                }
            }
            return TimeSpan.MaxValue;
        }
        long lastUsed;
        public int lastCast;
        public bool onCooldown(int Spell)
        {
            SpellFindResults Results;
            if (SpellManager.FindSpell(Spell, out Results))
            {
                WoWSpell Result = Results.Override ?? Results.Original;
                if (Cooldowns.TryGetValue(Result, out lastUsed))
                {
                    if (DateTime.Now.Ticks < lastUsed)
                        return Result.Cooldown;
                    return false;
                }
            }
            return false;
        }
        public bool onCooldown(string Spell)
        {
            SpellFindResults Results;
            if (SpellManager.FindSpell(Spell, out Results))
            {
                WoWSpell Result = Results.Override ?? Results.Original;
                if (Cooldowns.TryGetValue(Result, out lastUsed))
                {
                    if (DateTime.Now.Ticks < lastUsed)
                        return Result.Cooldown;
                    return false;
                }
            }
            return false;
        }
        public TimeSpan spellCooldownLeft(int Spell, bool useTracker = false)
        {
            if (useTracker)
                return cooldownLeft(Spell);
            SpellFindResults results;
            if (SpellManager.FindSpell(Spell, out results))
            {
                if (results.Override != null)
                    return results.Override.CooldownTimeLeft;
                return results.Override.CooldownTimeLeft;
            }
            return TimeSpan.MaxValue;
        }
        public TimeSpan spellCooldownLeft(string Spell, bool useTracker = false)
        {
            if (useTracker)
                return cooldownLeft(Spell);
            SpellFindResults results;
            if (SpellManager.FindSpell(Spell, out results))
            {
                if (results.Override != null)
                    return results.Override.CooldownTimeLeft;
                return results.Override.CooldownTimeLeft;
            }
            return TimeSpan.MaxValue;
        }
        public bool spellOnCooldown(int Spell, bool useTracker = false)
        {
            if (useTracker)
                return !onCooldown(Spell);
            SpellFindResults results;
            if (SpellManager.FindSpell(Spell, out results))
                return results.Override != null ? results.Override.Cooldown : results.Original.Cooldown;
            return false;
        }
        public bool spellOnCooldown(string Spell, bool useTracker = false)
        {
            if (useTracker)
                return !onCooldown(Spell);
            SpellFindResults results;
            if (SpellManager.FindSpell(Spell, out results))
                return results.Override != null ? results.Override.Cooldown : results.Original.Cooldown;
            return false;
        }
        #endregion

        #region Debuff Checks

        public bool debuffExists(int Debuff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                WoWAura aura = onTarget.GetAllAuras().FirstOrDefault(a => a.SpellId == Debuff && a.CreatorGuid == Me.Guid);
                if (aura != null)
                {
                    return true;
                }
            }
            return false;
        }

        public double debuffTimeLeft(int Debuff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                WoWAura aura = onTarget.GetAllAuras().FirstOrDefault(a =>
                    a.SpellId == Debuff
                    && a.CreatorGuid == Me.Guid);

                if (aura == null)
                {
                    return 0;
                }
                return aura.TimeLeft.TotalMilliseconds;
            }
            return 0;
        }

        public uint debuffStackCount(int Debuff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                WoWAura aura = onTarget.GetAllAuras().FirstOrDefault(a =>
                    a.SpellId == Debuff
                    && a.CreatorGuid == Me.Guid);

                if (aura == null)
                {
                    return 0;
                }
                return aura.StackCount;
            }
            return 0;
        }
        public bool debuffExists(string Debuff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                WoWAura aura = onTarget.GetAllAuras().FirstOrDefault(a => a.Name == Debuff && a.CreatorGuid == Me.Guid);
                if (aura != null)
                {
                    return true;
                }
            }
            return false;
        }

        public double debuffTimeLeft(string Debuff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                WoWAura aura = onTarget.GetAllAuras().FirstOrDefault(a =>
                    a.Name == Debuff
                    && a.CreatorGuid == Me.Guid);

                if (aura == null)
                {
                    return 0;
                }
                return aura.TimeLeft.TotalMilliseconds;
            }
            return 0;
        }

        public uint debuffStackCount(string Debuff, WoWUnit onTarget)
        {
            if (onTarget != null)
            {
                WoWAura aura = onTarget.GetAllAuras().FirstOrDefault(a =>
                    a.Name == Debuff
                    && a.CreatorGuid == Me.Guid);

                if (aura == null)
                {
                    return 0;
                }
                return aura.StackCount;
            }
            return 0;
        }
        #endregion

        #region Timer Checks
        public bool isTargetDummy
        {
            get
            {
                return Me.CurrentTarget.Name.Contains("Dummy");
            }
        }
        private int conv_Date2Timestam(DateTime _time)
        {
            var date1 = new DateTime(1970, 1, 1);
            DateTime date2 = _time;
            var ts = new TimeSpan(date2.Ticks - date1.Ticks);
            return (Convert.ToInt32(ts.TotalSeconds));
        }
        private uint current_life;
        private int current_time;
        private ulong guid;
        private uint first_life;
        private uint first_life_max;
        private int first_time;
        public long targetExistence(WoWUnit onTarget)
        {
            if (onTarget == null) return 0;
            if (isTargetDummy) return 9999;
            if (onTarget.CurrentHealth == 0 || onTarget.IsDead || !onTarget.IsValid || !onTarget.IsAlive)
                return 0;
            if (guid != onTarget.Guid)
            {
                guid = onTarget.Guid;
                first_life = onTarget.CurrentHealth;
                first_life_max = onTarget.MaxHealth;
                first_time = conv_Date2Timestam(DateTime.Now);
            }
            current_life = onTarget.CurrentHealth;
            current_time = conv_Date2Timestam(DateTime.Now);
            var time_diff = current_time - first_time;
            var hp_diff = first_life - current_life;
            if (hp_diff > 0)
            {
                var full_time = time_diff * first_life_max / hp_diff;
                var past_first_time = (first_life_max - first_life) * time_diff / hp_diff;
                var calc_time = first_time - past_first_time + full_time - current_time;
                if (calc_time < 1) calc_time = 99;
                var time_to_die = calc_time;
                var fight_length = full_time;
                return time_to_die;
            }
            if (hp_diff < 0)
            {
                guid = onTarget.Guid;
                first_life = onTarget.CurrentHealth;
                first_life_max = onTarget.MaxHealth;
                first_time = conv_Date2Timestam(DateTime.Now);
                return -1;
            }
            if (current_life == first_life_max)
                return 9999;
            return -1;
        }
        #endregion
    }
}
