﻿using Styx.Helpers;
using System.IO;
using Styx;
using Styx.Common;
using System.ComponentModel;
using DefaultValue = Styx.Helpers.DefaultValueAttribute;
using Styx.TreeSharp;

namespace HSV
{
    public class CRHotKeySettings : Settings
    {
        public static readonly CRHotKeySettings myPrefs = new CRHotKeySettings();

        public CRHotKeySettings()
            : base(
                Path.Combine(Utilities.AssemblyDirectory,
                    string.Format(@"Routines/HSV/Settings/{0}/HotKeySettingsHSV-{1}.xml", StyxWoW.Me.RealmName, StyxWoW.Me.Name))
                )
        {
        }
        

        [Setting]
        [DefaultValue(HSVKeys.A)]
        [Category("Pause Aoe")]
        [DisplayName("Pause Aoe Key")]
        [Description("enable/disable Aoe Mode")]
        public HSVKeys StopAoeKey { get; set; }

        [Setting, DefaultValue(ModifierKeys.Shift)]
        [Category("Pause Aoe")]
        [DisplayName("Pause Aoe ModKey")]
        [Description("Mod key for Pause Aoe Key")]
        public ModifierKeys PauseAoeKey { get; set; }

        [Setting]
        [DefaultValue(HSVKeys.P)]
        [Category("Pause")]
        [DisplayName("Pause CR Key")]
        [Description("enable/disable Pause Mode")]
        public HSVKeys StopCRKey { get; set; }

        [Setting, DefaultValue(ModifierKeys.Shift)]
        [Category("Pause")]
        [DisplayName("Pause ModKey")]
        [Description("Mod key for Pause Key")]
        public ModifierKeys PauseKey { get; set; }

        [Setting]
        [DefaultValue(true)]
        [Category("Hotkeys")]
        [DisplayName("Print Raidstyle Messages")]
        public bool PrintRaidstyleMsg { get; set; }


        //burst
        [Setting, DefaultValue(HSVKeys.X)]
        [Category("Burst")]
        [DisplayName("Burst Key")]
        [Description("enable/disable Burst Mode")]
        public HSVKeys BurstKey { get; set; }

        [Setting, DefaultValue(ModifierKeys.Shift)]
        [Category("Burst")]
        [DisplayName("Burst ModKey")]
        [Description("Mod key for Burst Key")]
        public ModifierKeys ModKey { get; set; }

    }
}
