﻿using CommonBehaviors.Actions;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Media;
using Action = Styx.TreeSharp.Action;

namespace HSV
{
    public partial class Main : CombatRoutine
    {
        public override string Name { get { return "HSV by Pasterke"; } }
        public override WoWClass Class { get { return WoWClass.Hunter; } }
        public LocalPlayer Me { get { return StyxWoW.Me; } }
        public override Composite CombatBehavior { get { return CreateCombat(); } }
        public override Composite PreCombatBuffBehavior { get { return CreatePreCombatBuffs(); } }
        public override Composite CombatBuffBehavior { get { return CreateCombatBuffs(); } }
        public override Composite PullBehavior { get { return CreatePull(); } }
        public override Composite PullBuffBehavior { get { return CreatePullBuffs(); } }
        public override Composite RestBehavior { get { return CreateRest(); } }

        public string usedBot { get { return BotManager.Current.Name.ToUpper(); } }

        private static bool IsInGame
        {
            get { return StyxWoW.IsInGame; }
        }

        public override bool WantButton { get { return true; } }
        public override void OnButtonPress()
        {
            Form1 ConfigForm = new Form1();
            ConfigForm.ShowDialog();
        }

        public override void Initialize()
        {
            LogMsg("My ZoneID = " + Me.ZoneId);
            EventHandlers.AttachCombatLogEvent();
            InitializeHotkey();
            RegisterHotkeys();
        }

        public override void Pulse()
        {
            try
            {
                if (Me.IsDead && AutoBot)
                {
                    Lua.DoString(string.Format("RunMacroText(\"{0}\")", "/script RepopMe()"));
                }
                if (Me.Pet != null && Me.GotAlivePet && nextPetCallCheckAllowed <= DateTime.Now && LastPetCall != string.Empty)
                {
                    LastPetCall = string.Empty;
                }
                if (Me.ZoneId == 6757 && CanBuff && SettingsCommon.myPrefs.AutoTimelessIsleBuffs)
                {
                    checkBuffs();
                }
                return;
            }
            catch { }
        }

        #region Hotkeys
        public static bool BurstEnabled = false;
        public static bool Paused = false;
        public static bool PauseAoe = false;

        public static void InitializeHotkey()
        {
            HotkeysManager.Initialize(StyxWoW.Memory.Process.MainWindowHandle);
        }
        public static void RegisterHotkeys()
        {
            HotkeysManager.Register("Burst Key", (Keys)CRHotKeySettings.myPrefs.BurstKey, CRHotKeySettings.myPrefs.ModKey, hk =>
            {
                BurstEnabled = !BurstEnabled;
                if (BurstEnabled)
                {
                    string myChatMsg = "Burst Key Activated, press Burst key again to Deactivate";
                    if (CRHotKeySettings.myPrefs.PrintRaidstyleMsg)
                        Lua.DoString(
                            "RaidNotice_AddMessage(RaidWarningFrame, \"" + myChatMsg + "\", ChatTypeInfo[\"RAID_WARNING\"]);");
                    Lua.DoString(@"print('Burst Key \124cFFE61515 Enabled!')");
                    Logging.Write("Burst Key Enabled");
                }
                else
                {
                    string myChatMsg = "Burst Key Disabled";
                    if (CRHotKeySettings.myPrefs.PrintRaidstyleMsg)
                        Lua.DoString(
                            "RaidNotice_AddMessage(RaidWarningFrame, \"" + myChatMsg + "\", ChatTypeInfo[\"RAID_WARNING\"]);");
                    Lua.DoString(@"print('Burst Key \124cFF15E61C Disabled!')");
                    Logging.Write("Burst Key Disabled!");
                }
            });
            HotkeysManager.Register("Pause Key", (Keys)CRHotKeySettings.myPrefs.StopCRKey, CRHotKeySettings.myPrefs.ModKey, hk =>
            {
                Paused = !Paused;
                if (Paused)
                {
                    string myChatMsg = "CR Paused ! Press Pause Key to Activate Routine again.";
                    if (CRHotKeySettings.myPrefs.PrintRaidstyleMsg)
                        Lua.DoString(
                            "RaidNotice_AddMessage(RaidWarningFrame, \"" + myChatMsg + "\", ChatTypeInfo[\"RAID_WARNING\"]);");
                    Lua.DoString(@"print('Pause Key \124cFFE61515 Enabled!')");
                    Logging.Write("Pause Key Enabled");
                }
                else
                {
                    string myChatMsg = "CR Running Again";
                    if (CRHotKeySettings.myPrefs.PrintRaidstyleMsg)
                        Lua.DoString(
                            "RaidNotice_AddMessage(RaidWarningFrame, \"" + myChatMsg + "\", ChatTypeInfo[\"RAID_WARNING\"]);");
                    Lua.DoString(@"print('Pause Key \124cFF15E61C Disabled!')");
                    Logging.Write("Pause Key Disabled!");
                }
            });
            HotkeysManager.Register("Pause Aoe Key", (Keys)CRHotKeySettings.myPrefs.StopAoeKey, CRHotKeySettings.myPrefs.ModKey, hk =>
            {
                PauseAoe = !PauseAoe;
                if (PauseAoe)
                {
                    string myChatMsg = "AOE disabled ! Press Pause Aoe Key to Activate AOE again.";
                    if (CRHotKeySettings.myPrefs.PrintRaidstyleMsg)
                        Lua.DoString(
                            "RaidNotice_AddMessage(RaidWarningFrame, \"" + myChatMsg + "\", ChatTypeInfo[\"RAID_WARNING\"]);");
                    Lua.DoString(@"print('Pause Aoe Key \124cFFE61515 Enabled!')");
                    Logging.Write("Pause AOE Key Enabled");
                }
                else
                {
                    string myChatMsg = "AOE resumed !";
                    if (CRHotKeySettings.myPrefs.PrintRaidstyleMsg)
                        Lua.DoString(
                            "RaidNotice_AddMessage(RaidWarningFrame, \"" + myChatMsg + "\", ChatTypeInfo[\"RAID_WARNING\"]);");
                    Lua.DoString(@"print('Pause Aoe Key \124cFF15E61C Disabled!')");
                    Logging.Write("Pause Aoe Key Disabled!");
                }
            });
        }
        public void RemoveHotkeys()
        {
            HotkeysManager.Unregister("Burst Key");
            HotkeysManager.Unregister("Pause Key");
            HotkeysManager.Unregister("Pause Aoe Key");
        }

        public void ReRegisterHotkeys()
        {
            RemoveHotkeys();
            RegisterHotkeys();
        }
        #endregion

        Composite CreateRest()
        {
            return new PrioritySelector(
                new Decorator(ret => Paused, isCRPaused()),
                new Decorator(ret => CanEat && Me.HealthPercent <= SettingsCommon.myPrefs.PercentEatFood, EatFood()),
                new Decorator(ret => CanBuff
                    && Me.GotAlivePet
                    && Me.Pet.HealthPercent <= SettingsCommon.myPrefs.PercentMendPet
                    && !buffExists(MEND_PET, Me.Pet)
                    && nextMendPetAllowed <= DateTime.Now, CastMendPet())
                );
        }
        Composite CreatePullBuffs()
        {
            return new PrioritySelector(
                new Decorator(ret => Paused, isCRPaused()),
                new Decorator(ret => IsInGame,
                    new PrioritySelector(
                        new Decorator(ret => CanBuff && LastPetCall == string.Empty && Me.Pet == null && SettingsCommon.myPrefs.CallAutoPet, CallPet()),
                        new Decorator(ret => CanBuff && Me.Pet != null && Me.Pet.IsDead, ReviveMyPet()),
                        new Decorator(ret => CanBuff && nextBuffAllowed <= DateTime.Now, BuffAspect()),
                        new Decorator(ret => CanBuff && !buffExists(TRAP_LAUNCHER, Me) && nextBuffAllowed <= DateTime.Now, BuffTrapLauncher()),
                        new Decorator(ret => CanBuff 
                            && Me.GotAlivePet
                            && Me.Pet.HealthPercent <= SettingsCommon.myPrefs.PercentMendPet
                            && !buffExists(MEND_PET, Me.Pet)
                            && nextMendPetAllowed <= DateTime.Now, CastMendPet()),
                        new Decorator(ret => CanBuff
                            && SettingsCommon.myPrefs.AutoUseAlchemyFlask
                            && nextBuffAllowed <= DateTime.Now
                            && !HaveFlaskBuff && !buffExists("Enhanced Agility", Me)
                            && !buffExists(CRYSTAL_OF_INSANITY_BUFF, Me), AlchemyFlask()),
                        new Decorator(ret => CanBuff
                            && !Me.CurrentMap.IsArena
                            && SettingsCommon.myPrefs.AutoUseCrystalOfInsanity
                            && nextCrystalUseAllowed <= DateTime.Now
                            && !HaveFlaskBuff
                            && !buffExists(CRYSTAL_OF_INSANITY_BUFF, Me), CrystalOfInsanity())
                        ))
                );
        }
        Composite CreatePreCombatBuffs()
        {
            return new PrioritySelector(
                new Decorator(ret => Paused, isCRPaused()),
                new Decorator(ret => IsInGame,
                    new PrioritySelector(
                        new Decorator(ret => CanBuff && LastPetCall == string.Empty && Me.Pet == null && SettingsCommon.myPrefs.CallAutoPet, CallPet()),
                        new Decorator(ret => CanBuff && Me.Pet != null && Me.Pet.IsDead, ReviveMyPet()),
                        new Decorator(ret => CanBuff && nextBuffAllowed <= DateTime.Now, BuffAspect()),
                        new Decorator(ret => CanBuff && !buffExists(TRAP_LAUNCHER, Me) && nextBuffAllowed <= DateTime.Now, BuffTrapLauncher()),
                        new Decorator(ret => CanBuff
                            && Me.GotAlivePet
                            && Me.Pet.HealthPercent <= SettingsCommon.myPrefs.PercentMendPet
                            && !buffExists(MEND_PET, Me.Pet)
                            && nextMendPetAllowed <= DateTime.Now, CastMendPet()),
                        new Decorator(ret => CanBuff
                            && SettingsCommon.myPrefs.AutoUseAlchemyFlask
                            && nextBuffAllowed <= DateTime.Now
                            && !HaveFlaskBuff && !buffExists("Enhanced Agility", Me)
                            && !buffExists(CRYSTAL_OF_INSANITY_BUFF, Me), AlchemyFlask()),
                        new Decorator(ret => CanBuff
                            && !Me.CurrentMap.IsArena
                            && SettingsCommon.myPrefs.AutoUseCrystalOfInsanity
                            && nextCrystalUseAllowed <= DateTime.Now
                            && !HaveFlaskBuff
                            && !buffExists(CRYSTAL_OF_INSANITY_BUFF, Me), CrystalOfInsanity())
                        ))
                );
        }
        Composite CreateCombatBuffs()
        {
            return new PrioritySelector(
                new Decorator(ret => Paused, isCRPaused()),
                new Decorator(ret => IsInGame,
                    new PrioritySelector(
                        new Decorator(ret => CanBuff && LastPetCall == string.Empty && Me.Pet == null && SettingsCommon.myPrefs.CallAutoPet, CallPet()),
                        new Decorator(ret => CanBuff && Me.Pet != null && Me.Pet.IsDead, ReviveMyPet()),
                        new Decorator(ret => CanBuff && nextBuffAllowed <= DateTime.Now, BuffAspect()),
                        new Decorator(ret => CanBuff && !buffExists(TRAP_LAUNCHER, Me) && nextBuffAllowed <= DateTime.Now, BuffTrapLauncher()),
                        new Decorator(ret => Me.GotAlivePet 
                            && Me.Pet.HealthPercent <= SettingsCommon.myPrefs.PercentMendPet
                            && !buffExists(MEND_PET, Me.Pet)
                            && nextMendPetAllowed <= DateTime.Now, CastMendPet()),
                        new Decorator(ret =>  CanBuff && Me.HealthPercent <= SettingsCommon.myPrefs.PercentHealthstone, Healthstone()),
                        new Decorator(ret => CanBuff
                            && SettingsCommon.myPrefs.AutoUseAlchemyFlask
                            && nextBuffAllowed <= DateTime.Now
                            && !HaveFlaskBuff && !buffExists("Enhanced Agility", Me)
                            && !buffExists(CRYSTAL_OF_INSANITY_BUFF, Me), AlchemyFlask()),
                        new Decorator(ret => CanBuff
                            && SettingsCommon.myPrefs.AutoUseFlaskOfSpringBlossom != SettingsCommon.FlaskUse.Manual
                            && nextBuffAllowed <= DateTime.Now
                            && !HaveFlaskBuff, FlaskOfSpringBlossom()),
                        new Decorator(ret => CanBuff
                            && !Me.CurrentMap.IsArena
                            && SettingsCommon.myPrefs.AutoUseCrystalOfInsanity
                            && nextCrystalUseAllowed <= DateTime.Now
                            && !HaveFlaskBuff
                            && !buffExists(CRYSTAL_OF_INSANITY_BUFF, Me), CrystalOfInsanity())
                        ))
                );
        }
        Composite CreatePull()
        {
            return new PrioritySelector(
                new Decorator(ret => Paused, isCRPaused()),
                new Decorator(ret => gotTarget && AutoBot && Me.CurrentTarget.IsFriendly, new Action(ret => { Me.ClearTarget(); return RunStatus.Failure; })),
                new Decorator(ret => gotTarget && AutoBot && (Me.CurrentTarget.Distance >= 39 || !Me.CurrentTarget.InLineOfSight), CreateMovementBehavior()),
                new Decorator(ret => gotTarget && AutoBot && Me.CurrentTarget.Distance <= 39 && Me.CurrentTarget.InLineOfSight && Me.IsMoving, CreateStopMovement()),
                new Decorator(ret => gotTarget && AutoBot && !Me.IsSafelyFacing(Me.CurrentTarget), FaceMyTarget()),
                new Decorator(ret => gotTarget
                    && AutoBot
                    && SpellManager.HasSpell(MISIRECTION)
                    && !buffExists(MISIRECTION, Me)
                    && !spellOnCooldown(MISIRECTION)
                    && Me.CurrentTarget.InLineOfSight
                    && IsInRange(40, Me.CurrentTarget)
                    && nextMisShotAllowed <= DateTime.Now, CastMisdirection()),
                new Decorator(ret => gotTarget
                    && AutoBot
                    && SpellManager.HasSpell(CONCUSSIVE_SHOT)
                    && !debuffExists(CONCUSSIVE_SHOT, Me.CurrentTarget)
                    && IsInRange(40, Me.CurrentTarget)
                    && nextConShotAllowed <= DateTime.Now, CastConcussiveShot()),
                new Decorator(ret => gotTarget
                    && AutoBot
                    && Me.FocusPercent >= 30
                    && IsInRange(40, Me.CurrentTarget), CastArcaneShot())
                );
        }
        Composite CreateCombat()
        {
            return new PrioritySelector(
                new Decorator(ret => Paused, isCRPaused()),
                new Decorator(ret => gotTarget 
                    && SettingsCommon.myPrefs.DisengageDistance != 0
                    && Me.CurrentTarget.Distance <= SettingsCommon.myPrefs.DisengageDistance
                    && !spellOnCooldown(DISENGAGE)
                    && nextDisengageAllowed <= DateTime.Now, CastDisengage()),
                new Decorator(ret => Me.Pet != null && Me.Pet.IsDead, new Action(ret => { SpellManager.Cast("Revive Pet"); })),
                new Decorator(ret => gotTarget && AutoBot && Me.CurrentTarget.IsFriendly, new Action(ret => { Me.ClearTarget(); return RunStatus.Failure; })),
                new Decorator(ret => (Me.CurrentTarget == null || Me.CurrentTarget.IsDead)
                    && Me.GotAlivePet
                    && (Me.PetAggro || Me.PetInCombat),
                    new Action(ret => { Me.Pet.CurrentTarget.Target(); 
                        Logging.Write(Colors.Pink, "Taking my Pet's Target " + Me.Pet.CurrentTarget.Name); 
                        return RunStatus.Failure; })),
                new Decorator(ret => AllowTargeting && (Me.CurrentTarget == null || Me.CurrentTarget.IsDead), new Action(ret => { FindTarget(); return RunStatus.Failure; })),
                new Decorator(ret => gotTarget && AllowMovement && (Me.CurrentTarget.Distance >= 39 || !Me.CurrentTarget.InLineOfSight), CreateMovementBehavior()),
                new Decorator(ret => gotTarget && AllowMovement && Me.CurrentTarget.Distance <= 39 && Me.CurrentTarget.InLineOfSight && Me.IsMoving, CreateStopMovement()),
                new Decorator(ret => gotTarget && AllowFacing && !Me.IsSafelyFacing(Me.CurrentTarget), FaceMyTarget()),
                new Decorator(ret => gotTarget
                    && SpellManager.HasSpell(COUNTER_SHOT)
                    && !spellOnCooldown(COUNTER_SHOT)
                    && Me.CurrentTarget.IsCasting
                    && Me.CanInterruptCurrentSpellCast
                    && nextCounterShotAllowed <= DateTime.Now, CastCounterShot()),
                //Aoe
                new Decorator(ret => gotTarget 
                    && SpellManager.HasSpell(MULTI_SHOT) 
                    && !PauseAoe 
                    && UnfriendlyRangedUnits.Count() >= SettingsCommon.myPrefs.StartAoe,
                    new PrioritySelector(
                        new Decorator(ret => gotTarget
                            && SpellManager.HasSpell(MISIRECTION)
                            && !buffExists(MISIRECTION, Me)
                            && !spellOnCooldown(MISIRECTION)
                            && ((SettingsCommon.myPrefs.MisdirectionUse == SettingsCommon.useMisdirect.Auto
                            && Me.ThreatInfo.RawPercent >= 90) || MeIsSolo)
                            && nextMisShotAllowed <= DateTime.Now, CastMisdirection()),
                        new Decorator(ret => gotTarget
                            && IsOverlayed(EXPLOSIVE_SHOT_INT), CastExplosiveShotproc()),
                        new Decorator(ret => gotTarget
                            && buffExists(TRAP_LAUNCHER, Me)
                            && SpellManager.HasSpell(EXPLOSIVE_TRAP)
                            && !spellOnCooldown(EXPLOSIVE_TRAP)
                            && IsInRange(40, Me.CurrentTarget)
                            && nextTrapAllowed <= DateTime.Now, CastExplosiveTrap()),
                        new Decorator(ret => gotTarget
                            && buffExists(TRAP_LAUNCHER, Me)
                            && SpellManager.HasSpell(SNAKE_TRAP)
                            && !spellOnCooldown(SNAKE_TRAP)
                            && IsInRange(40, Me.CurrentTarget)
                            && nextTrapAllowed <= DateTime.Now, CastSnakeTrap()),
                        new Decorator(ret => gotTarget
                            && Me.FocusPercent >= 40, CastMultiShot())
                        )),
                //Normal Rotation
                new Decorator(ret => gotTarget
                    && SpellManager.HasSpell(MISIRECTION)
                    && !buffExists(MISIRECTION, Me)
                    && !spellOnCooldown(MISIRECTION)
                    && ((SettingsCommon.myPrefs.MisdirectionUse == SettingsCommon.useMisdirect.Auto
                    && Me.ThreatInfo.RawPercent >= 90) || MeIsSolo)
                    && nextMisShotAllowed <= DateTime.Now, CastMisdirection()),
                new Decorator(ret => gotTarget 
                    && (Me.IsMoving || Me.CurrentTarget.IsPlayer)
                    && !spellOnCooldown(CONCUSSIVE_SHOT) 
                    && !debuffExists(CONCUSSIVE_SHOT, Me.CurrentTarget)
                    && nextConShotAllowed <= DateTime.Now, CastConcussiveShot()),
                new Decorator(ret => gotTarget
                    && !spellOnCooldown(KILL_SHOT)
                    && Me.CurrentTarget.HealthPercent <= 20
                    && nextKillShotAllowed <= DateTime.Now, CastKillShot()),
                new Decorator(ret => gotTarget 
                    && IsOverlayed(EXPLOSIVE_SHOT_INT), CastExplosiveShotproc()),
                new Decorator(ret => gotTarget
                    && SpellManager.HasSpell(SNAKE_TRAP)
                    && buffExists(TRAP_LAUNCHER, Me)
                    && Me.GotAlivePet
                    && Me.Pet.IsWithinMeleeRangeOf(Me.CurrentTarget)
                    && !spellOnCooldown(SNAKE_TRAP)
                    && IsWoWBoss(Me.CurrentTarget)
                    && IsInRange(40, Me.CurrentTarget)
                    && nextTrapAllowed <= DateTime.Now, CastSnakeTrap()),
                new Decorator(ret => gotTarget
                    && SpellManager.HasSpell(EXPLOSIVE_TRAP)
                    && buffExists(TRAP_LAUNCHER, Me)
                    && Me.GotAlivePet 
                    && Me.Pet.IsWithinMeleeRangeOf(Me.CurrentTarget)
                    && !spellOnCooldown(EXPLOSIVE_TRAP)
                    && IsWoWBoss(Me.CurrentTarget)
                    && IsInRange(40, Me.CurrentTarget)
                    && nextTrapAllowed <= DateTime.Now, CastExplosiveTrap()),
                new Decorator(ret => gotTarget
                    && !spellOnCooldown(RAPID_FIRE)
                    && nextRapidFireAllowed <= DateTime.Now, CastRapidFire()),
                new Decorator(ret => gotTarget
                    && Me.FocusPercent >= 15
                    && !debuffExists(SERPENT_STING, Me.CurrentTarget) 
                    && nextSerpentStingAllowed <= DateTime.Now, CastSerpentSting()),
                new Decorator(ret => gotTarget 
                    && Me.FocusPercent >= 35
                    && !debuffExists(BLACK_ARROW, Me.CurrentTarget)
                    && !spellOnCooldown(BLACK_ARROW)
                    && nextBlackArrowAllowed <= DateTime.Now, CastBlackArrow()),
                new Decorator(ret => gotTarget
                    && Me.FocusPercent >= 25
                    && !spellOnCooldown(EXPLOSIVE_SHOT)
                    && nextExplosiveShotAllowed <= DateTime.Now, CastExplosiveShot()),
                new Decorator(ret => gotTarget
                    && Me.FocusPercent >= 15
                    && !spellOnCooldown(GLAIVE_TOSS)
                    && nextGlaiveTossAllowed <= DateTime.Now, CastGlaiveToss()),
                new Decorator(ret => gotTarget 
                    && !spellOnCooldown(DIRE_BEAST) 
                    && nextDireBeastAllowed <= DateTime.Now, CastDireBeast()),

                // Burst Mode
                new Decorator(ret => gotTarget
                    && BurstKeySettings.myPrefs.useBurstMode
                    && SpellManager.HasSpell(RAPID_FIRE)
                    && !spellOnCooldown(RAPID_FIRE)
                    && BurstEnabled 
                    && BurstKeySettings.myPrefs.useBurstRapidFire
                    && targetExistence(Me.CurrentTarget) > 15
                    && nextRapidFireAllowed <= DateTime.Now, CastRapidFire()),
                new Decorator(ret => gotTarget
                    && BurstKeySettings.myPrefs.useBurstMode
                    && !spellOnCooldown(STAMPEDE)
                    && BurstEnabled 
                    && BurstKeySettings.myPrefs.useBurstStampede
                    && targetExistence(Me.CurrentTarget) > 20
                    && nextStampedeAllowed <= DateTime.Now, CastStampede()),
                new Decorator(ret => gotTarget
                    && BurstKeySettings.myPrefs.useBurstMode
                    && !spellOnCooldown(MURDER_OF_CROWS)
                    && BurstEnabled 
                    && BurstKeySettings.myPrefs.useBurstCrows
                    && targetExistence(Me.CurrentTarget) > 30
                    && Me.FocusPercent >= 60
                    && nextMurderOfCrowsAllowed <= DateTime.Now, CastMurderOfCrows()),
                new Decorator(ret => gotTarget
                    && BurstKeySettings.myPrefs.useBurstMode
                    && SettingsCommon.myPrefs.Trinket1Use != SettingsCommon.TrinketsUse.Manual
                    && BurstEnabled 
                    && BurstKeySettings.myPrefs.useBurstTrinket1
                    && nextTrinketTimeAllowed <= DateTime.Now, Trinket1()),
                new Decorator(ret => gotTarget
                    && BurstKeySettings.myPrefs.useBurstMode
                    && SettingsCommon.myPrefs.Trinket2Use != SettingsCommon.TrinketsUse.Manual
                    && BurstEnabled
                    && BurstKeySettings.myPrefs.useBurstTrinket2
                    && nextTrinketTimeAllowed <= DateTime.Now, Trinket2()),
                new Decorator(ret => gotTarget
                    && BurstKeySettings.myPrefs.useBurstMode
                    && SettingsCommon.myPrefs.GlovesChoice != SettingsCommon.useEngiGloves.Manual
                    && BurstEnabled 
                    && BurstKeySettings.myPrefs.useBurstEngiGloves
                    && nextTrinketTimeAllowed <= DateTime.Now, Trinket1()),
                new Decorator(ret => gotTarget
                    && BurstKeySettings.myPrefs.useBurstMode
                    && SpellManager.HasSpell(BERSERKING)
                    && BurstEnabled 
                    && BurstKeySettings.myPrefs.useBurstBerserking
                    && !spellOnCooldown(BERSERKING)
                    && NotHaveHasteBuffs
                    && nextBerserkingAllowed <= DateTime.Now, CastBerserking()),
                new Decorator(ret => gotTarget
                    && BurstKeySettings.myPrefs.useBurstMode
                    && SpellManager.HasSpell(BLOOD_FURY)
                    && !spellOnCooldown(BLOOD_FURY)
                    && BurstEnabled 
                    && BurstKeySettings.myPrefs.useBurstBloodFury
                    && targetExistence(Me.CurrentTarget) > 15
                    && nextBloodFuryAllowed <= DateTime.Now, CastBloodFury()),
                // End Burst Mode

                new Decorator(ret => gotTarget
                    && SpellManager.HasSpell(RAPID_FIRE)
                    && !spellOnCooldown(RAPID_FIRE)
                    && (!BurstKeySettings.myPrefs.useBurstMode || (BurstKeySettings.myPrefs.useBurstMode && !BurstKeySettings.myPrefs.useBurstRapidFire))
                    && IsWoWBoss(Me.CurrentTarget)
                    && targetExistence(Me.CurrentTarget) > 15
                    && nextRapidFireAllowed <= DateTime.Now, CastRapidFire()),
                new Decorator(ret => gotTarget 
                    && !spellOnCooldown(STAMPEDE)
                    && (!BurstKeySettings.myPrefs.useBurstMode || (BurstKeySettings.myPrefs.useBurstMode && !BurstKeySettings.myPrefs.useBurstStampede))
                    && IsWoWBoss(Me.CurrentTarget)
                    && targetExistence(Me.CurrentTarget) > 20
                    && nextStampedeAllowed <= DateTime.Now, CastStampede()),
                new Decorator(ret => gotTarget 
                    && !spellOnCooldown(MURDER_OF_CROWS)
                    && (!BurstKeySettings.myPrefs.useBurstMode || (BurstKeySettings.myPrefs.useBurstMode && !BurstKeySettings.myPrefs.useBurstCrows))
                    && IsWoWBoss(Me.CurrentTarget)
                    && Me.FocusPercent >= 60 
                    && targetExistence(Me.CurrentTarget) > 30
                    && nextMurderOfCrowsAllowed <= DateTime.Now, CastMurderOfCrows()),
                new Decorator(ret => gotTarget
                    && SettingsCommon.myPrefs.Trinket1Use != SettingsCommon.TrinketsUse.Manual
                    && (!BurstKeySettings.myPrefs.useBurstMode || (BurstKeySettings.myPrefs.useBurstMode && !BurstKeySettings.myPrefs.useBurstTrinket1))
                    && IsWoWBoss(Me.CurrentTarget)
                    && nextTrinketTimeAllowed <= DateTime.Now, Trinket1()),
                new Decorator(ret => gotTarget
                    && SettingsCommon.myPrefs.Trinket2Use != SettingsCommon.TrinketsUse.Manual
                    && (!BurstKeySettings.myPrefs.useBurstMode || (BurstKeySettings.myPrefs.useBurstMode && !BurstKeySettings.myPrefs.useBurstTrinket2))
                    && IsWoWBoss(Me.CurrentTarget)
                    && nextTrinketTimeAllowed <= DateTime.Now, Trinket2()),
                new Decorator(ret => gotTarget
                    && SettingsCommon.myPrefs.GlovesChoice != SettingsCommon.useEngiGloves.Manual
                    && (!BurstKeySettings.myPrefs.useBurstMode || (BurstKeySettings.myPrefs.useBurstMode && !BurstKeySettings.myPrefs.useBurstEngiGloves))
                    && IsWoWBoss(Me.CurrentTarget)
                    && nextTrinketTimeAllowed <= DateTime.Now, Trinket1()),
                new Decorator(ret => gotTarget
                    && SpellManager.HasSpell(BERSERKING)
                    && (!BurstKeySettings.myPrefs.useBurstMode || (BurstKeySettings.myPrefs.useBurstMode && !BurstKeySettings.myPrefs.useBurstBerserking))
                    && !spellOnCooldown(BERSERKING)
                    && IsWoWBoss(Me.CurrentTarget)
                    && NotHaveHasteBuffs
                    && nextBerserkingAllowed <= DateTime.Now, CastBerserking()),
                new Decorator(ret => gotTarget
                    && SpellManager.HasSpell(BLOOD_FURY)
                    && !spellOnCooldown(BLOOD_FURY)
                    && (!BurstKeySettings.myPrefs.useBurstMode || (BurstKeySettings.myPrefs.useBurstMode && !BurstKeySettings.myPrefs.useBurstBloodFury))
                    && IsWoWBoss(Me.CurrentTarget)
                    && targetExistence(Me.CurrentTarget) > 15
                    && nextBloodFuryAllowed <= DateTime.Now, CastBloodFury()),
                new Decorator(ret => gotTarget 
                    && Me.FocusPercent >= 65, CastArcaneShot()),
                new Decorator(ret => gotTarget 
                    && Me.Level >= 81 
                    && Me.FocusPercent <= 40
                    && nextFocusShotAllowed <= DateTime.Now, CastCobraShot()),
                new Decorator(ret => gotTarget 
                    && Me.Level < 81 
                    && Me.FocusPercent <= 40
                    && nextFocusShotAllowed <= DateTime.Now, CastSteadyShot())
                );
        }

        

    }
}




