﻿using CommonBehaviors.Actions;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.Pathing;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Windows.Media;
using Action = Styx.TreeSharp.Action;

namespace HSV
{
    public partial class Main : CombatRoutine
    {
        #region useitems
        private DateTime nextEngiGlovesUseAllowed;

        public void SetNexEngiGlovesUseAllowed()
        {
            nextEngiGlovesUseAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 25000);
        }
        private DateTime nextTrinketTimeAllowed;

        public void SetNextNextTrinketTimeAllowed()
        {
            nextTrinketTimeAllowed = DateTime.Now + new TimeSpan(0, 0, 0, 0, 5000);
        }
        private DateTime nextHealthstoneUseAllowed;

        public void SetNextHealthstoneUseAllowed()
        {
            nextHealthstoneUseAllowed = DateTime.Now + new TimeSpan(0, 0, 1, 59, 0);
        }
        private DateTime nextCrystalUseAllowed;

        public void SetNextCrystalUseAllowed()
        {
            nextCrystalUseAllowed = DateTime.Now + new TimeSpan(0, 0, 15, 0, 0);
        }
        private static bool CanUseEquippedItem(WoWItem item)
        {
            // Check for engineering tinkers!
            string itemSpell = Lua.GetReturnVal<string>("return GetItemSpell(" + item.Entry + ")", 0);
            if (string.IsNullOrEmpty(itemSpell))
                return false;


            return item.Usable && item.Cooldown <= 0;
        }

        Composite Trinket1()
        {
            return
                    new Action(ret =>
                    {
                        var firstTrinket = StyxWoW.Me.Inventory.Equipped.Trinket1;

                        if (SettingsCommon.myPrefs.Trinket1Use == SettingsCommon.TrinketsUse.Below_HealthPercent
                            && Me.HealthPercent <= SettingsCommon.myPrefs.trinket1hppercent
                            && firstTrinket != null
                            && CanUseEquippedItem(firstTrinket))
                        {
                            firstTrinket.Use();
                            SetNextNextTrinketTimeAllowed();
                        }
                        if (SettingsCommon.myPrefs.Trinket1Use == SettingsCommon.TrinketsUse.CrowdControlled
                            && IsCrowdControlledPlayer(Me)
                            && firstTrinket != null
                            && CanUseEquippedItem(firstTrinket))
                        {
                            firstTrinket.Use();
                            SetNextNextTrinketTimeAllowed();
                        }
                        if (SettingsCommon.myPrefs.Trinket1Use == SettingsCommon.TrinketsUse.DPS_Boost
                            && IsWoWBoss(Me.CurrentTarget)
                            && firstTrinket != null
                            && CanUseEquippedItem(firstTrinket))
                        {
                            firstTrinket.Use();
                            SpellManager.ClickRemoteLocation(Me.CurrentTarget.Location);
                            SetNextNextTrinketTimeAllowed();
                        }
                        return RunStatus.Failure;
                    });
        }
        Composite Trinket2()
        {
            return
                    new Action(ret =>
                    {
                        var secondTrinket = StyxWoW.Me.Inventory.Equipped.Trinket2;

                        if (SettingsCommon.myPrefs.Trinket2Use == SettingsCommon.TrinketsUse.Below_HealthPercent
                            && Me.HealthPercent <= SettingsCommon.myPrefs.trinket2hppercent
                            && secondTrinket != null
                            && CanUseEquippedItem(secondTrinket))
                        {
                            secondTrinket.Use();
                            SetNextNextTrinketTimeAllowed();
                        }
                        if (SettingsCommon.myPrefs.Trinket2Use == SettingsCommon.TrinketsUse.CrowdControlled
                            && IsCrowdControlledPlayer(Me)
                            && secondTrinket != null
                            && CanUseEquippedItem(secondTrinket))
                        {
                            secondTrinket.Use();
                            SetNextNextTrinketTimeAllowed();
                        }
                        if (SettingsCommon.myPrefs.Trinket2Use == SettingsCommon.TrinketsUse.DPS_Boost
                            && IsWoWBoss(Me.CurrentTarget)
                            && secondTrinket != null
                            && CanUseEquippedItem(secondTrinket))
                        {
                            secondTrinket.Use();
                            SpellManager.ClickRemoteLocation(Me.CurrentTarget.Location);
                            SetNextNextTrinketTimeAllowed();
                        }
                        return RunStatus.Failure;

                    });
        }
        Composite EngineerGloves()
        {
            return new Action(ret =>
            {
                var gloves = StyxWoW.Me.Inventory.Equipped.Hands;
                if (SettingsCommon.myPrefs.GlovesChoice == SettingsCommon.useEngiGloves.BossFights
                    && IsWoWBoss(Me.CurrentTarget) && CanUseEquippedItem(gloves) && gloves.Usable)
                {
                    gloves.Use();
                    SetNexEngiGlovesUseAllowed();
                    Logging.Write(Colors.DeepPink, "Using Engineer Gloves");
                    return RunStatus.Success;
                }
                if (SettingsCommon.myPrefs.GlovesChoice == SettingsCommon.useEngiGloves.OnCoolDown
                    && CanUseEquippedItem(gloves) && gloves.Usable)
                {
                    gloves.Use();
                    SetNexEngiGlovesUseAllowed();
                    Logging.Write(Colors.DeepPink, "Using Engineer Gloves");
                    return RunStatus.Success;
                }
                return RunStatus.Failure;
            });
        }
        Composite Healthstone()
        {
            return
                new Action(ret =>
                {
                    var hstone = ObjectManager.GetObjectsOfType<WoWItem>().FirstOrDefault(item => item.Entry == 5512);
                    if (hstone != null && hstone.Usable)
                    {
                        hstone.Use();
                        Logging.Write("Using Healthstone");
                        SetNextHealthstoneUseAllowed();
                    }
                    return RunStatus.Failure;
                });
        }
        Composite AlchemyFlask()
        {
            return
                new Action(ret =>
                {
                    var alchflask = ObjectManager.GetObjectsOfType<WoWItem>().FirstOrDefault(item => item.Entry == 75525);
                    if (alchflask != null && alchflask.Usable)
                    {
                        alchflask.Use();
                        SetNextBuffAllowed();
                    }
                    return RunStatus.Failure;
                });
        }
        Composite CrystalOfInsanity()
        {
            return new Action(ret =>
            {
                var crystal = ObjectManager.GetObjectsOfType<WoWItem>().FirstOrDefault(item => item.Entry == 86569);
                if (crystal != null && crystal.Usable)
                {
                    crystal.Use();
                    SetNextCrystalUseAllowed();
                }
                return RunStatus.Failure;
            });
        }
        
        Composite FlaskOfSpringBlossom()
        {
            return new Action(ret =>
            {
                if (buffExists(CRYSTAL_OF_INSANITY_BUFF, Me) && SettingsCommon.myPrefs.AutoUseFlaskOfSpringBlossom != SettingsCommon.FlaskUse.Manual)
                {
                    Lua.DoString("RunMacroText(\"/Cast !" + CRYSTAL_OF_INSANITY_BUFF + "\")");
                }
                var earth = ObjectManager.GetObjectsOfType<WoWItem>().FirstOrDefault(item => item.Entry == FLASK_OF_SPRING_BLOSSOMS);
                if (earth != null
                    && earth.Usable
                    && SettingsCommon.myPrefs.AutoUseFlaskOfSpringBlossom == SettingsCommon.FlaskUse.Dungeons
                    && (Me.CurrentMap.IsDungeon || Me.CurrentMap.IsInstance))
                {
                    earth.Use();
                    SetNextBuffAllowed();
                }
                if (earth != null
                    && earth.Usable
                    && earth.Cooldown <= 0
                    && SettingsCommon.myPrefs.AutoUseFlaskOfSpringBlossom == SettingsCommon.FlaskUse.Raids_but_not_LFR
                    && Me.CurrentMap.IsRaid
                    && !Me.GroupInfo.IsInLfgParty)
                {
                    earth.Use();
                    SetNextBuffAllowed();
                }
                if (earth != null
                    && earth.Usable
                    && earth.Cooldown <= 0
                    && SettingsCommon.myPrefs.AutoUseFlaskOfSpringBlossom == SettingsCommon.FlaskUse.Raids
                    && Me.CurrentMap.IsRaid)
                {
                    earth.Use();
                    SetNextBuffAllowed();
                }
                return RunStatus.Failure;
            });
        }
        #endregion

        #region flask buffs
        //flask id's
        public int CRYSTAL_OF_INSANITY_ITEM = 86569;
        public int FLASK_OF_THE_WARM_SUN = 76085;
        public int FLASK_OF_WINTERS_BITE = 76088;
        public int FLASK_OF_THE_EARTH = 76087;
        public int FLASK_OF_SPRING_BLOSSOMS = 76084;
        public int FLASK_OF_FALING_LEAVES = 76086;

        //flaskbuff id's
        public int CRYSTAL_OF_INSANITY_BUFF = 127230;
        public int Flask_OF_THE_EARTH_BUFF = 105694;
        public int Flask_OF_THE_WARM_SUN_BUFF = 105691;
        public int FLASK_OF_WINTERS_BITE_BUFF = 105696;
        public int FLASK_OF_FALLING_LEAVES_BUFF = 105693;
        public int FLASK_OF_SPRING_BLOSSOMS_BUFF = 105698;

        public bool HaveFlaskBuff
        {
            get
            {
                return buffExists(Flask_OF_THE_EARTH_BUFF, Me)
                    || buffExists(Flask_OF_THE_WARM_SUN_BUFF, Me)
                    || buffExists(FLASK_OF_WINTERS_BITE_BUFF, Me)
                    || buffExists(FLASK_OF_FALLING_LEAVES_BUFF, Me)
                    || buffExists(FLASK_OF_SPRING_BLOSSOMS_BUFF, Me);
            }
        }
        #endregion

    }
}
